## Contributing to Caddy

**[Join our dev chat on Gitter](https://gitter.im/mholt/caddy)** to chat with
other Caddy developers! (Dev chat only; try our
[support room](https://gitter.im/caddyserver/support) for help or
[general](https://gitter.im/caddyserver/general) for anything else.)

This project gladly accepts contributions and we encourage interested users to 
get involved!


#### For small tweaks, bug fixes, and tests

Submit [pull requests](https://github.com/mholt/caddy/pulls) at any time. 
Bug fixes should be under test to assert correct behavior. Thank you for
helping out in simple ways!


#### Ideas, questions, bug reports

Feel free to [open an issue](https://github.com/mholt/caddy/issues) with your
ideas, questions, and bug reports, if one does not already exist for it. Bug
reports should state expected behavior and contain clear instructions for
isolating and reproducing the problem.
See [How to Report Bugs Effectively](http://www.chiark.greenend.org.uk/~sgtatham/bugs.html).


#### New features

Before submitting a pull request, please open an issue first to discuss it and 
claim it. This prevents overlapping efforts and keeps the project in-line with 
its goals. If you prefer to discuss the feature privately, you can reach other 
developers on Gitter or you may email me directly. (My email address is below.)

And don't forget to write tests for new features!


#### Vulnerabilities

If you've found a vulnerability that is serious, please email me: Matthew dot 
Holt at Gmail. If it's not a big deal, a pull request will probably be faster.


## Thank you

Thanks for your help! Caddy would not be what it is today without your contributions.
